/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

var currentlyBeingSpoken = null;

// setup() is called when the body of the widget is loaded.  This function places the localized
// strings into the widget.


function setup()
{
/*	if(window.widget) {
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"Welcome to iSpeak!\" using \"Vicki\"'" , doneSpeaking);
	}
*/	
}


function voiceChanged(elem)
{
	var chosenVoice = elem.options[elem.selectedIndex].value;
	document.getElementById("voiceMenuText").innerText = chosenVoice;
	
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
			done();
		}
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"Hi, I`m " + chosenVoice + ".\" using \"" + chosenVoice + "\"'" , doneSpeaking);	
	}

}

function speak(event)
{


	document.getElementById("speakButton").src = "Images/Button_down.png";
	
	var textToSpeak = document.getElementById('textInput').value;
	var regExForSingleQuote = new RegExp ('\'', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForSingleQuote, '`') ;
	var regExForDoubleQuote = new RegExp ('"', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForDoubleQuote, '') ;

	var voiceMenu = document.getElementById('voicePopup');
	var chosenVoice = voiceMenu.options[voiceMenu.selectedIndex].value;

	var speakButtonText = document.getElementById("speakButtonText");
	speakButtonText.style.left = "100px";
	speakButtonText.innerText = "Stop";
	
	var theButton = document.getElementById("theButton");
	theButton.onmousedown = null;
	theButton.onmousedown = cancel;

	
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
		}
		    
		document.getElementById("busyspeaking").style.display = "visible";
		document.getElementById("textInput").style.display = "none";    
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + textToSpeak + "\" using \"" + chosenVoice + "\"'" , done);	
	}
}

function cancel(event)
{
	if(window.widget) {
		currentlyBeingSpoken.cancel();
	}
	
	document.getElementById("speakButton").src = "Images/Button_down.png";

	done();
}

function done()
{
	var speakButtonText = document.getElementById("speakButtonText");
	speakButtonText.style.left = "96px";
	speakButtonText.innerText = "Speak";

	var theButton = document.getElementById("theButton");

	theButton.onmousedown = null;
	theButton.onmousedown = speak;
	
	doneSpeaking();
}

function doneSpeaking()
{
	currentlyBeingSpoken = null;
    document.getElementById("busyspeaking").style.display = "none";	
	document.getElementById("textInput").style.display = "visible";
}

function buttonUpOut()
{
	document.getElementById("speakButton").src = "Images/Button.png";
}


function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
